# data_mining_qa/qa.py

def explain_data_mining_architecture():
    """Returns an explanation of data mining architecture."""
    return "Data mining architecture consists of a data warehouse, database, data mining engine, pattern evaluation module, and user interface. The data warehouse stores integrated data, and the data mining engine extracts patterns with the help of various algorithms."

def define_data_mining_pros_and_cons():
    """Returns the definition and pros/cons of data mining."""
    return "Data mining is the process of discovering patterns and knowledge from large datasets. Pros: Helps in decision-making, predictive analysis, and finding hidden patterns. Cons: Privacy concerns, potential data misuse, and high computational costs."

def data_mining_tasks():
    """Returns the different tasks in data mining."""
    return "Data mining tasks include classification, clustering, regression, association rule mining, and anomaly detection. For example, in classification, data is grouped into predefined categories, like spam or not spam in email filtering."

def sources_of_data_for_mining():
    """Returns a list of data sources used for mining."""
    return "Data sources for mining include databases, data warehouses, flat files, web data, and social media data. These sources provide structured or unstructured data to analyze and extract useful information."

def define_data_mining_applications():
    """Defines data mining and its applications."""
    return "Data mining is the extraction of patterns from large datasets. Applications include market analysis, fraud detection, healthcare, and customer relationship management."

def problems_on_clustering():
    """Returns information on clustering problems."""
    return "Clustering problems involve grouping data points into clusters based on similarity. Challenges include determining the optimal number of clusters and handling high-dimensional data."

def problem_on_classification():
    """Returns information on classification problems."""
    return "Classification problems involve assigning data into predefined categories. Challenges include data imbalance, feature selection, and improving model accuracy."

def disciplines_contributing_to_data_mining():
    """Returns a list of disciplines contributing to data mining."""
    return "Disciplines contributing to data mining include statistics, machine learning, database management, artificial intelligence, and information retrieval."

def sources_and_handling_missing_values():
    """Returns information on how missing values are handled in data mining."""
    return "Data sources like surveys and transactional data often have missing values. Techniques to handle missing values include mean imputation, regression imputation, and using algorithms that handle missing data natively."

def note_on_sampling():
    """Returns a note on sampling in data mining."""
    return "Sampling is the process of selecting a subset of data from a larger dataset for analysis. Techniques include random sampling, stratified sampling, and systematic sampling, which help reduce computational costs and improve efficiency."
